Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.Cli/Program.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.Cli/Program.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.Cli/Program.cs	(revision 14602)
@@ -26,19 +26,19 @@
 
       Console.WriteLine("\nPress any key to continue...");
+
+      //if (args.Length == 0) return;
+
+      //var code = args[0];
+      //EvaluateStepwise(code).Wait();
+
       Console.ReadKey();
     }
 
-    static void SimpleTest() {
-      var interpreter = new PushGpInterpreter();
-
-      interpreter.Interpret("5 INTEGER.DUP INTEGER.+");
-
-      interpreter.PrintStacks();
-    }
-
-    static async Task Stepwise() {
-      var interpreter = new PushGpInterpreter();
-
-      interpreter.InterpretAsync("( 0 2 CODE.QUOTE ( 1 INTEGER.+ 0 3 CODE.QUOTE ( 1 INTEGER.+ INTEGER.* ) CODE.DO*RANGE INTEGER.+ ) CODE.DO*RANGE )", true).Wait();
+    static async Task EvaluateStepwise(string code) {
+      var interpreter = new PushGpInterpreter(new Configuration {
+        TopLevelPushCode = false
+      });
+
+      interpreter.RunAsync(code, true).Wait();
 
       while (!interpreter.IsCompleted) {
@@ -59,4 +59,34 @@
     }
 
+    static void SimpleTest() {
+      var interpreter = new PushGpInterpreter();
+
+      interpreter.Run("5 INTEGER.DUP INTEGER.+");
+
+      interpreter.PrintStacks();
+    }
+
+    static async Task Stepwise() {
+      var interpreter = new PushGpInterpreter();
+
+      interpreter.RunAsync("( 0 2 CODE.QUOTE ( 1 INTEGER.+ 0 3 CODE.QUOTE ( 1 INTEGER.+ INTEGER.* ) CODE.DO*RANGE INTEGER.+ ) CODE.DO*RANGE )", true).Wait();
+
+      while (!interpreter.IsCompleted) {
+        Console.Clear();
+        interpreter.PrintStacks();
+        interpreter.Step();
+
+        var input = Console.ReadKey();
+        if (input.Key == ConsoleKey.Escape) {
+          break;
+        } else if (input.Key == ConsoleKey.Spacebar) {
+          await interpreter.ResumeAsync();
+        }
+      }
+
+      Console.Clear();
+      interpreter.PrintStacks();
+    }
+
     static void PerformanceTestInterpreter() {
       var program = PushGPParser.Parse("( 5 INTEGER.DUP INTEGER.+ )");
@@ -67,5 +97,5 @@
       sw.Start();
       for (var i = 0; i < 60000000; i++) {
-        interpreter.Interpret(program);
+        interpreter.Run(program);
         interpreter.Clear();
       }
@@ -94,5 +124,5 @@
 
           for (var j = 0; j < amount; j++) {
-            interpreter.Interpret(program);
+            interpreter.Run(program);
             interpreter.Clear();
           }
@@ -111,5 +141,5 @@
       sw.Stop();
 
-      Console.WriteLine(string.Format("Generated {0} in {1}", expressions.Count(), sw.Elapsed));
+      Console.WriteLine("Generated {0} in {1}", expressions.Count(), sw.Elapsed);
     }
 
@@ -131,5 +161,5 @@
             var program = CodeGenerator.RandomProgram(maxProgramSizeLimit);
 
-            interpreter.Interpret(program);
+            interpreter.Run(program);
 
             execCounters[i] += interpreter.ExecCounter;
@@ -150,5 +180,5 @@
 
       using (var interpreter = pool.GetInstance()) {
-        interpreter.Interpret("( 1 2 INTEGER.+ )");
+        interpreter.Run("( 1 2 INTEGER.+ )");
 
         id = interpreter.GetHashCode();
@@ -158,5 +188,5 @@
       using (var interpreter = pool.GetInstance())
       using (var interpreter2 = pool.GetInstance()) {
-        interpreter.Interpret("( 1 2 INTEGER.+ )");
+        interpreter.Run("( 1 2 INTEGER.+ )");
         if (id == interpreter.GetHashCode()) Console.WriteLine("equal 2");
         if (id == interpreter2.GetHashCode()) Console.WriteLine("equal 3");
@@ -198,5 +228,5 @@
         solution => {
           interpreter.Clear();
-          interpreter.Interpret(solution);
+          interpreter.Run(solution);
           return interpreter.IntegerStack.Top == 10;
         });
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Attributes/PushExpressionAttriubte.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Attributes/PushExpressionAttriubte.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Attributes/PushExpressionAttriubte.cs	(revision 14602)
@@ -0,0 +1,14 @@
+﻿using System;
+
+namespace HeuristicLab.Algorithms.PushGP.Attributes {
+  [AttributeUsage(AttributeTargets.Class)]
+  public class PushExpressionAttribute : Attribute {
+    public readonly string StackName;
+    public readonly string ExpressionName;
+
+    public PushExpressionAttribute(string stackName, string expressionName) {
+      this.StackName = stackName;
+      this.ExpressionName = expressionName;
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Pool/ObjectPool.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Pool/ObjectPool.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Pool/ObjectPool.cs	(revision 14602)
@@ -25,5 +25,5 @@
   ///    If there is no intent for reusing the object, do not use pool - just use "new".
   /// </summary>
-  internal sealed class ObjectPool<T> where T : class, IRecyclable {
+  internal sealed class ObjectPool<T> where T : class {
     private struct Element {
       internal T Value;
@@ -71,5 +71,4 @@
         if (inst != null) {
           if (inst == Interlocked.CompareExchange(ref items[i].Value, null, inst)) {
-            inst.Recycle();
             goto gotInstance;
           }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Random/RandomFactory.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Random/RandomFactory.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Random/RandomFactory.cs	(revision 14602)
@@ -1,4 +1,5 @@
 ﻿namespace HeuristicLab.Algorithms.PushGP.Data.Random {
   using System;
+  using System.Collections.Generic;
   using System.Threading;
 
@@ -9,12 +10,27 @@
     public static readonly RandomFactory Instance = new RandomFactory();
 
+    private static int seed;
+    private static IList<IRandom> randoms = new List<IRandom>();
+
     static RandomFactory() {
       Seed = Environment.TickCount;
     }
 
-    public static int Seed;
+    public static int Seed
+    {
+      get { return seed; }
+      set
+      {
+        seed = value;
+
+        for (var i = 0; i < randoms.Count; i++) {
+          randoms[i].Reset(seed);
+        }
+      }
+    }
 
     public static ThreadLocal<IRandom> GetRandom() {
-      return new ThreadLocal<IRandom>(() => new FastRandom(Seed/*Interlocked.Increment(ref Seed)*/));
+      /*Interlocked.Increment(ref Seed)*/
+      return new ThreadLocal<IRandom>(() => new FastRandom(Seed));
     }
   }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/BooleanExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/BooleanExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/BooleanExpressions.cs	(revision 14602)
@@ -5,9 +5,7 @@
   ///     Pushes the logical AND of the top two BOOLEANs.
   /// </summary>
+  //[PushExpression("BOOLEAN", "AND")]
   public class BooleanAndExpression : PushResultExpression<bool> {
-    protected override string InitStringRepresentation() {
-      return "BOOLEAN.AND";
-    }
-
+    public BooleanAndExpression() : base("BOOLEAN.AND") { }
     public override void Eval(IPushGpInterpreter interpreter) {
       this.Eval(interpreter.BooleanStack, 2, values => values[0] && values[1]);
@@ -18,8 +16,7 @@
   ///     Pushes the logical OR of the top two BOOLEANs.
   /// </summary>
+  //[PushExpression("BOOLEAN", "OR")]
   public class BooleanOrExpression : PushResultExpression<bool> {
-    protected override string InitStringRepresentation() {
-      return "BOOLEAN.OR";
-    }
+    public BooleanOrExpression() : base("BOOLEAN.OR") { }
 
     public override void Eval(IPushGpInterpreter interpreter) {
@@ -31,8 +28,7 @@
   ///     Pushes the logical NOT of the top BOOLEAN.
   /// </summary>
+  //[PushExpression("BOOLEAN", "NOT")]
   public class BooleanNotExpression : PushResultExpression<bool> {
-    protected override string InitStringRepresentation() {
-      return "BOOLEAN.NOT";
-    }
+    public BooleanNotExpression() : base("BOOLEAN.NOT") { }
 
     public override void Eval(IPushGpInterpreter interpreter) {
@@ -45,7 +41,5 @@
   /// </summary>
   public class BooleanFromFloatExpression : StatelessExpression {
-    protected override string InitStringRepresentation() {
-      return "BOOLEAN.FROMFLOAT";
-    }
+    public BooleanFromFloatExpression() : base("BOOLEAN.FROMFLOAT") { }
 
     public override void Eval(IPushGpInterpreter interpreter) {
@@ -62,7 +56,5 @@
   /// </summary>
   public class BooleanFromIntegerExpression : StatelessExpression {
-    protected override string InitStringRepresentation() {
-      return "BOOLEAN.FROMINTEGER";
-    }
+    public BooleanFromIntegerExpression() : base("BOOLEAN.FROMINTEGER") { }
 
     public override void Eval(IPushGpInterpreter interpreter) {
